<template>
  <div>
    <data-table ref="datatable" :get-data="getBugBounties">
      <template slot="table-toolbar">
        <div class="md-toolbar-section-start">
          <h1 class="md-title">Bug Bounty</h1>
        </div>

        <md-button class="md-raised md-button-primary" style="margin-right: 20px;" @click="showConfirmApproveAllDialog">Approve all</md-button>

        <md-field md-clearable class="md-field-search md-toolbar-section-end">
          <md-input placeholder="Search by user or title ..." v-model="search" @input="searchBounties"/>
        </md-field>
      </template>

      <md-table-head class="col1">#</md-table-head>
      <md-table-head class="col2">User</md-table-head>
      <md-table-head class="col3">Title</md-table-head>
      <md-table-head class="col4">Description</md-table-head>
      <md-table-head class="col5">Status</md-table-head>
      <md-table-head class="col6">Action</md-table-head>

      <template slot="body" slot-scope="{ item, index }">
        <md-table-row >
          <md-table-cell class="col1"> {{ index + 1 }}</md-table-cell>
          <md-table-cell class="col2">{{ item.user.email }}</md-table-cell>
          <md-table-cell class="col3">{{ item.title }}</md-table-cell>
          <md-table-cell class="col4">{{ item.description }}</md-table-cell>
          <md-table-cell class="col5" :class="item.status">{{ item.status | referralType }}</md-table-cell>
          <md-table-cell class="col6">
            <div v-if="item.status === 'pending'">
              <md-button class="md-raised md-button-primary" @click="showConfirmApproveDialog(item)">Approve
              </md-button>
              <md-button class="md-raised md-accent" @click="showConfirmRejectDialog(item)">Reject</md-button>
            </div>
          </md-table-cell>
        </md-table-row>
      </template>
    </data-table>

    <md-dialog-confirm
      :md-active.sync="isShowConfirmApproveDialog"
      md-title="Are you sure you want to approve?"
      md-confirm-text="Agree"
      md-cancel-text="Disagree"
      @md-cancel="onCancelApprove"
      @md-confirm="onConfirmApprove"/>
    <md-dialog-confirm
      :md-active.sync="isShowConfirmRejectDialog"
      md-title="Are you sure you want to reject?"
      md-confirm-text="Agree"
      md-cancel-text="Disagree"
      @md-cancel="onCancelReject"
      @md-confirm="onConfirmReject"/>
    <md-dialog-confirm
      :md-active.sync="isShowConfirmApproveAllDialog"
      md-title="Are you sure want to approve all this type?"
      md-confirm-text="Agree"
      md-cancel-text="Disagree"
      @md-confirm="onConfirmApproveAll"/>
  </div>
</template>

<script>
  import rf from '../../common/requests/RequestFactory';

  export default {
    data () {
      return {
        search: '',
        bountyWillApprove: {},
        bountyWillReject: {},
        isShowConfirmApproveDialog: false,
        isShowConfirmRejectDialog: false,
        isShowConfirmApproveAllDialog: false,
      }
    },
    filters: {
      referralType (value) {
        return _.chain(value)
          .lowerCase()
          .upperFirst()
          .value();
      },
    },
    methods: {
      onConfirmApproveAll() {
        this.approveAllType();
        this.$toasted.show('You approved successfully!', {
          theme: 'bubble',
          position: 'top-right',
          duration: 2000
        });
      },
      showConfirmApproveAllDialog () {
        this.isShowConfirmApproveAllDialog = true;
      },
      showConfirmApproveDialog (bounty) {
        this.isShowConfirmApproveDialog = true;
        this.bountyWillApprove = bounty;
      },

      showConfirmRejectDialog (bounty) {
        this.isShowConfirmRejectDialog = true;
        this.bountyWillReject = bounty;
      },

      onConfirmApprove () {
        this.updateBounty(this.bountyWillApprove, 'approved');
        this.bountyWillApprove = {};
        this.$toasted.show('You approved successfully!', {
          theme: 'bubble',
          position: 'top-right',
          duration: 2000
        });
      },

      onCancelApprove () {
        this.bountyWillApprove = {};
      },

      onConfirmReject () {
        this.updateBounty(this.bountyWillReject, 'rejected');
        this.bountyWillReject = {};
        this.$toasted.show('You rejected successfully!', {
          theme: 'bubble',
          position: 'top-right',
          duration: 2000
        });
      },

      onCancelReject () {
        this.bountyWillReject = {};
      },

      refreshDataTable () {
        this.$refs.datatable.refresh();
      },

      searchBounties: _.debounce(function() {
        this.refreshDataTable();
      }, 500),

      getBugBounties (params) {
        const meta = Object.assign({}, {
          like_operator: 'or',
          like: {
            'users.email': this.search,
            title: this.search,
            description: this.search,
          },
          with: 'user',
        });
        return rf.getRequest('BugBountyRequest').getAll(Object.assign({}, params, meta));
      },
      updateBounty (bounty, status) {
        bounty.status = status;
        rf.getRequest('BugBountyRequest').update(bounty.id, bounty).then(res => {
          this.refreshDataTable();
        });
      },
      approveAllType () {
        rf.getRequest('BugBountyRequest').approveAllType().then(res => {
          this.refreshDataTable();
        });
      },
    },
  }
</script>

<style lang="scss">
  .product__paginate {
    li {
      display: inline-block;
    }
  }

  .pagination-prev,
  .pagination-next {
    position: relative;

    a {
      position: relative;
      z-index: 1;
    }
  }

  .pagination-prev:before,
  .pagination-next:before {
    content: '';
    display: block;
    width: 10px;
    height: 10px;
    background-image: url('/images/prev.png');
    background-size: cover;
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }

  .pagination-next:before {
    background-image: url('/images/next.png');
  }
</style>

<style lang="scss" scoped>
  .md-field-filter-status {
    margin-right: 15px;
    max-width: 300px;
  }

  .md-field-search {
    max-width: 400px;
  }

  .md-card .md-card-content {
    padding: 0px 20px;
  }

  .md-card {
    margin: 0px;
  }

  .col1 {
    width: 100px;
    max-width: 100px;
    word-wrap: break-word;
  }

  .col2 {
    width: 300px;
    max-width: 300px;
    word-wrap: break-word;
  }

  .col3 {
    width: 300px;
    max-width: 300px;
    word-wrap: break-word;
  }

  .col4 {
    width: 250px;
    max-width: 250px;
    word-wrap: break-word;
  }

  .col5 {
    width: 200px;
    max-width: 200px;
    &.pending {
      color: #8a6d3b;
      font-weight: 700;
    }
    &.approved {
      color: #3c763d;
      font-weight: 700;
    }
    &.rejected {
      color: #a94442;
      font-weight: 700;
    }
  }

  .col6 {
    width: 300px;
    max-width: 300px;
  }
</style>
